import { ExternalTokenizer, LRParser, LocalTokenGroup } from '@lezer/lr';
import { styleTags, tags } from '@lezer/highlight';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const range = 68;

const dot = 46;

const operatorToken = new ExternalTokenizer((input, stack) => {
    if (input.next === dot) {
        if (input.peek(-1) === dot) {
            input.advance();
            input.acceptToken(range);
        } else if (input.peek(1) === dot) {
            input.advance(); input.advance();
            input.acceptToken(range);
        }
    }
}, {contextual: true});

const exprHighlighting = styleTags({
  "let": tags.definitionKeyword,

  Number: tags.number,
  String: tags.string,
  Bool: tags.bool,
  Nil: tags.null,

  "and or not in contains startsWith endsWith matches": tags.operatorKeyword,
  LogicOp: tags.logicOperator,
  ArithmeticOp: tags.arithmeticOperator,
  CompareOp: tags.compareOperator,
  "|": tags.controlOperator,

  FieldName: tags.propertyName,
  VarName: tags.variableName,
  DefName: tags.definition(tags.variableName),
  "CallExpr/VarName CallExpr/*/FieldName": tags.function(tags.variableName),

  LineComment: tags.lineComment,
  BlockComment: tags.blockComment,

  Pointer: tags.atom,

  ". ?.": tags.derefOperator,
  "=": tags.definitionOperator,
  "; ,": tags.separator,
  ".. :": tags.punctuation,
  "( )": tags.paren,
  "[ ]": tags.squareBracket,
  "{ }": tags.brace,
});

// This file was generated by lezer-generator. You probably shouldn't edit it.
const spec_identifier = {__proto__:null,let:12, true:154, false:154, nil:26, not:94, in:102, contains:104, startsWith:106, endsWith:108, matches:110, and:114, or:118};
const parser = LRParser.deserialize({
  version: 14,
  states: "0tQ]QQOOP!^OQOOOOQP'#Cg'#CgOOQP'#Cj'#CjO$fQRO'#DpO%VQQO'#CqO`QQO'#CtO%[QQO'#CwO%fQQO'#C{OOQO'#DZ'#DZOOQO'#D['#D[O`QQO'#DYOOQP'#Dz'#DzOOQO'#Dl'#DlQ]QQOOQ`QQOOOOQP'#Ch'#ChO%zQQO'#CaP&POWO'#C^POOO)C?i)C?iO%VQQO,59VO%VQQO,59YO&[QQO,59jO`QQO,59lO'dQQO'#DSOOQP,59m,59mO`QQO,59rOOQO'#D_'#D_OOQO'#D`'#D`OOQO'#Df'#DfOOQO'#Dh'#DhO`QQO,59xO`QQO,59xO`QQO,59xO`QQO,59xO`QQO,59xO`QQO,5:UO'nQQO'#D`OOQP'#Cm'#CmOOQP,59],59]O(PQRO,59`O(WQRO'#D|OOQO'#D|'#D|O(bQQO,59cO(gQQO'#C|OOQO'#D}'#D}O(lQQO'#D}O(tQQO,59gOOQP,59t,59tOOQO-E7j-E7jOOQO-E7n-E7nOOQO'#Cc'#CcO(yQSO,58{POOO'#Dk'#DkP)OOWO,58xPOOO,58x,58xOOQP1G.q1G.qOOQP1G.t1G.tO)ZQRO1G/UO)eQQO1G/VO)lQRO1G/WO,nQRO'#EOO-pQQO'#C{O]QQO'#DUOOQO'#EO'#EOO.TQQO'#EOO.]QQO,59nO0[QRO1G/^O4ZQRO1G/dO4nQRO1G/dO7_QRO1G/dO8XQRO1G/dO:rQRO1G/dO<XQRO1G/pOOQO,59z,59zOOQP1G.z1G.zO<`QQO,5:hO<gQQO,5:hOOQP1G.}1G.}O`QQO,59hO<oQQO,5:iO=QQQO,5:iOOQP1G/R1G/RO`QQO1G.gPOOO-E7i-E7iPOOO1G.d1G.dOOQP7+$p7+$pO=YQQO7+$qO=aQRO7+$qOOQP7+$q7+$qO=hQQO,5:jO=oQQO,5:jO=wQRO'#CjO@QQRO,59oO@XQRO'#DzOBbQQO,59qOBgQRO,59pOOQP1G/Y1G/YO`QQO7+%[OBtQRO,5:XOCOQQO1G0SOOQO-E7k-E7kOCVQRO1G/SOOQO,5:Y,5:YOCaQQO1G0TOOQO-E7l-E7lOCrQRO7+$ROCyQRO<<H]OOQP<<H]<<H]ODQQRO,5:ZOOQO,5:Z,5:ZOD[QQO1G0UOOQO-E7m-E7mOOQO1G/Z1G/ZOOQO1G/]1G/]ODcQRO<<HvP`QQO'#DmPEoQQO'#DnOOQO<<Gm<<GmOOQPAN=wAN=wP&cQQO'#Do",
  stateData: "FU~O!hOSPOS!iPQ~OUaOX[OY[O]`O`TOd[OgUOjVOnWO!PYO!mRO!oQO!sXO!tXO!uYO~O!ibO~O`dOceOghOjfO{jO!PuO!TlO!UlO!VlO!WlO!XlO!ZmO!]nO!fgO!sXO!tXO!vkO!wkO!xkO!ykO!zkO!{lO!|lO!}lO#OlO#PlO#QlO#RmO#SnO#TnO#UtO~OX!dXY!dX]!dXd!dXn!dX!e!dX!m!dX!o!dX!u!dX~P!cO!mvO~OlzOi!pP~P`OX|OY|OgUOl}O!mvOm!qP~O!m!TO~O!j!VO!k!VO!l!XO~Oq!]O~P`OUaOX[OY[O]`O`TOd[OgUOjVOn!`O!PYO!mRO!oQO!sXO!tXO!uYO~Ol!bOf!rP~P&cO!T!lO!U!lO!V!lO!W!lO!X!lO~Of!mO~P!cOl!nOi!pX~P!cOi!pO~Oq!qO~Ol!rOm!qX~Om!tO~OW!uO~O!j!VO!k!VO!l!wO~Oi!xOq!yO~P!cOi!{O~P`O!fgOXtiYti]ti`tictidtigtijtinti{ti!Pti!Tti!Uti!Vti!Wti!Xti!Zti!]ti!eti!mti!oti!sti!tti!uti!vti!wti!xti!yti!zti!{ti!|ti!}ti#Oti#Pti#Qti#Rti#Sti#Tti#UtiftiitiltiqtimtiSti~Ol!|Of!rX~P!cOUaO]`O`TOd[OgUOjVOnWO!PYO!oQO!sXO!tXO!uYO~OX#QOY#QOl}O!m#OOm!qP~P,xOl!|Of!rX~Of#TO~O`dOghOjfO!PuO!TlO!UlO!VlO!WlO!XlO!ZmO!]nO!fgO!sXO!tXO!vkO!wkO!xkO!ykO!zkO!{lO!|lO!}lO#OlO#PlO#QlO#RmO#SnO#TnO~OXziYzi]ziczidzinzi{zi!ezi!mzi!ozi!uzi#UzifziizilziqzimziSzi~P.bO`dOghOjfO!fgOX!QiY!Qi]!Qic!Qid!Qin!Qi{!Qi!P!Qi!T!Qi!U!Qi!V!Qi!W!Qi!X!Qi!Z!Qi!]!Qi!e!Qi!m!Qi!o!Qi!s!Qi!t!Qi!u!Qi!{!Qi!|!Qi!}!Qi#O!Qi#P!Qi#Q!Qi#R!Qi#S!Qi#T!Qi#U!Qif!Qii!Qil!Qiq!Qim!QiS!Qi~O!v!Qi!w!Qi!x!Qi!y!Qi!z!Qi~P1hO!vkO!wkO!xkO!ykO!zkO~P1hO`dOghOjfO!fgO!sXO!tXO!vkO!wkO!xkO!ykO!zkOX!QiY!Qi]!Qic!Qid!Qin!Qi{!Qi!Z!Qi!]!Qi!e!Qi!m!Qi!o!Qi!u!Qi#R!Qi#S!Qi#T!Qi#U!Qif!Qii!Qil!Qiq!Qim!QiS!Qi~O!P!Qi!T!Qi!U!Qi!V!Qi!W!Qi!X!Qi!{!Qi!|!Qi!}!Qi#O!Qi#P!Qi#Q!Qi~P5RO!PuO!TlO!UlO!VlO!WlO!XlO!{lO!|lO!}lO#OlO#PlO#QlO~P5RO`dOghOjfO!PuO!TlO!UlO!VlO!WlO!XlO!ZmO!fgO!sXO!tXO!vkO!wkO!xkO!ykO!zkO!{lO!|lO!}lO#OlO#PlO#QlO#RmO~OX!QiY!Qi]!Qic!Qid!Qin!Qi{!Qi!]!Qi!e!Qi!m!Qi!o!Qi!u!Qi#S!Qi#T!Qi#U!Qif!Qii!Qil!Qiq!Qim!QiS!Qi~P9ROq#UO~P!cOi!pa~P`Ol#WOi!pa~OX|OY|OgUO!mvOm!qa~Ol#[Om!qa~Oi#`O~P`Oi#`O~P!cOf!ra~P&cOl#cOf!ra~O`^Xc^Xg^Xj^Xm^XqaX{^X!P^X!T^X!U^X!V^X!W^X!X^X!Z^X!]^X!f^X!s^X!t^X!v^X!w^X!x^X!y^X!z^X!{^X!|^X!}^X#O^X#P^X#Q^X#R^X#S^X#T^X#U^X~Om#eO~P!cOq!qO`!nXc!nXg!nXj!nXm!nX{!nX!P!nX!T!nX!U!nX!V!nX!W!nX!X!nX!Z!nX!]!nX!f!nX!s!nX!t!nX!v!nX!w!nX!x!nX!y!nX!z!nX!{!nX!|!nX!}!nX#O!nX#P!nX#Q!nX#R!nX#S!nX#T!nX#U!nX~Om#fO~Ofxalxamxa~P!cOi!aal!aa~P!cOi!pi~P`Olpimpi~P!cOX|OY|OgUO!mvOm!qi~OS#jO~P!cOi#kO~P!cOf!cal!ca~P!cOf!ri~P&cO{jO#UtOX!^yY!^y]!^yc!^yd!^yn!^y!e!^y!m!^y!o!^y!u!^yf!^yi!^yl!^yq!^ym!^yS!^y~P.bOX|OY|OgUO!mvO~OP!wX`X!m~",
  goto: ",f!sPP!tPP!wP#RPPP#U#UP#U#UP#u#UPP#UPP$VPP#UPPP#U%OP#U#U#U#U%X%p%x%p#UP#U&T'ZP#U'z(bPPPPP(vP)ZP#U)m)s*R*X*_*fPPPPPPPPP*mP,[,_,cRcPa]O^h!`!a!|#c#lR!Ua!][OUVZ^_fghjopqrst!]!`!a!n!q!u!y!|#U#W#c#h#lQwTY|W!`!r#[#iQ!YdR!Ze!Y[OUVZ^_fghjopqrst!]!a!n!q!u!y!|#U#W#c#h#lW|W!r#[#iR#Q!`S!OW!`V#Z!r#[#i{iSxy![!_!e!f!g!h!i!j!k!z#P#S#V#Y#^#_#a#gQ!chV#b!|#c#lQ!chQ#R!`V#b!|#c#l![ZOUVZ^_fghjopqrst!]!`!a!n!q!u!y!|#U#W#c#h#lwpSxy![!_!e!h!i!j!k!z#P#S#V#Y#^#_#a#g!]ZOUVZ^_fghjopqrst!]!`!a!n!q!u!y!|#U#W#c#h#lyoSxy![!_!e!g!h!i!j!k!z#P#S#V#Y#^#_#a#guqSxy![!_!e!i!j!k!z#P#S#V#Y#^#_#a#gsrSxy![!_!e!j!k!z#P#S#V#Y#^#_#a#gqsSxy![!_!e!k!z#P#S#V#Y#^#_#a#gQ!WbR!v!WQ^OS!R^!aZ!ah!`!|#c#lQ!oyR#X!oQ!s!OR#]!sS!}!_!cR#d!}S_O^R!S_USO^_QxUQyVQ!QZQ![fQ!^gQ!_hQ!ejQ!foQ!gpQ!hqQ!irQ!jsQ!ktQ!z!]Q#P!`Q#S!aU#V!n#W#hQ#Y!qQ#^!uQ#_!yU#a!|#c#lR#g#UR{VT!PW!`R!dh",
  nodeNames: "⚠ LineComment BlockComment Expr ; VarDecl let DefName = Number String Bool Nil nil VarName SelectorExpr . FieldName OptionalSelectorExpr ?. Pointer PointerSelectorExpr ) ( ParenthesizedExpr ] [ Array , } { Map Pair : IndexExpr SliceExpr RangeExpr CallExpr Arguments Block Predicate Block PipeExpr | UnaryExpr ArithmeticOp LogicOp not BinaryExpr ArithmeticOp CompareOp in contains startsWith endsWith matches LogicOp and LogicOp or ConditionalExpr",
  maxTerm: 98,
  nodeProps: [
    ["isolate", -3,1,2,10,""],
    ["group", -22,9,10,11,12,14,15,18,20,21,24,27,31,34,35,36,37,39,41,42,44,48,60,"Expr",40,"Expression"],
    ["openedBy", 22,"(",25,"[",29,"{"],
    ["closedBy", 23,")",26,"]",30,"}"]
  ],
  propSources: [exprHighlighting],
  skippedNodes: [0,1,2,61],
  repeatNodeCount: 6,
  tokenData: "3x~RwXY#lYZ#l]^#lpq#lqr#}rs$[st&Suv']vw'bwx'mxy)`yz)ez{)j{|)w|})|}!O*R!O!P*W!P!Q+f!Q!R,_!R![-e![!]0^!]!^0c!^!_0h!_!`0u!`!a1S!a!b1a!c!}1v!}#O2h#P#Q2m#Q#R2r#R#S1v#S#T2w#T#o1v#o#p3a#p#q3f#q#r3s$g;'S1v;'S;=`2b<%lO1v~#qS!h~XY#lYZ#l]^#lpq#l~$SP!u~!_!`$V~$[O!|~~$aWY~OY$[Zr$[rs$ys#O$[#O#P%O#P;'S$[;'S;=`%|<%lO$[~%OOY~~%RRO;'S$[;'S;=`%[;=`O$[~%aXY~OY$[Zr$[rs$ys#O$[#O#P%O#P;'S$[;'S;=`%|;=`<%l$[<%lO$[~&PP;=`<%l$[~&XUd~!c!}&k#R#S&k#T#o&k$g;'S&k;'S;=`'V<%lO&k~&pVd~!Q![&k!c!}&k#R#S&k#T#o&k$g;'S&k;'S;=`'V<%lO&k~'YP;=`<%l&k~'bO!x~~'ePvw'h~'mO#R~~'rWY~OY'mZw'mwx$yx#O'm#O#P([#P;'S'm;'S;=`)Y<%lO'm~(_RO;'S'm;'S;=`(h;=`O'm~(mXY~OY'mZw'mwx$yx#O'm#O#P([#P;'S'm;'S;=`)Y;=`<%l'm<%lO'm~)]P;=`<%l'm~)eOg~~)jOf~~)oP!v~z{)r~)wO!z~~)|O!s~~*ROl~~*WO!t~~*]P`~!Q![*`~*eSX~!Q![*`!g!h*q#R#S+`#X#Y*q~*tR{|*}}!O*}!Q![+T~+QP!Q![+T~+YQX~!Q![+T#R#S*}~+cP!Q![*`~+kQ!w~z{+q!P!Q+v~+vO!i~~+{SP~OY+vZ;'S+v;'S;=`,X<%lO+v~,[P;=`<%l+v~,dZX~!O!P-V!Q![-e!d!e.P!g!h*q!q!r.t!z!{/`#R#S-y#U#V.P#X#Y*q#c#d.t#l#m/`~-[RX~!Q![*`!g!h*q#X#Y*q~-jTX~!O!P-V!Q![-e!g!h*q#R#S-y#X#Y*q~-|P!Q![-e~.SR!Q!R.]!R!S.]#R#S.k~.bRX~!Q!R.]!R!S.]#R#S.k~.nQ!Q!R.]!R!S.]~.wQ!Q!Y.}#R#S/Y~/SQX~!Q!Y.}#R#S/Y~/]P!Q!Y.}~/cS!Q![/o!c!i/o#R#S0Q#T#Z/o~/tSX~!Q![/o!c!i/o#R#S0Q#T#Z/o~0TR!Q![/o!c!i/o#T#Z/o~0cOq~~0hOS~~0mP!}~!_!`0p~0uO#O~U0zPWS!_!`0}Q1SO!{Q~1XP#P~!_!`1[~1aO#Q~~1fQ#U~!O!P1l!a!b1q~1qOc~~1vO#T~~1{V!m~!Q![1v!c!}1v#R#S1v#T#o1v$g;'S1v;'S;=`2b<%lO1v~2eP;=`<%l1v~2mOj~~2rOi~~2wO!y~~2zTO#S2w#S#T$y#T;'S2w;'S;=`3Z<%lO2w~3^P;=`<%l2w~3fOn~~3kP{~#p#q3n~3sO#S~~3xOm~",
  tokenizers: [operatorToken, 1, 2, new LocalTokenGroup("j~RQYZXz{^~^O!k~~aP!P!Qd~iO!l~~", 25, 72)],
  topRules: {"Expr":[0,3]},
  specialized: [{term: 75, get: (value) => spec_identifier[value] || -1}],
  tokenPrec: 1701
});

export { parser };
